#include "dialogexportstl.h"
#include "ui_dialogexportstl.h"

DialogExportSTL::DialogExportSTL(QWidget *parent) :
    QDialog(parent),
    ui(new Ui::DialogExportSTL)
{
    ui->setupUi(this);
}

DialogExportSTL::~DialogExportSTL()
{
    delete ui;
}

void DialogExportSTL::on_buttonBox_accepted()
{
    QString options;

    if(ui->binary->isChecked()) options += "-b ";
    if(ui->inches->isChecked()) options += "-i ";
    if(ui->verbose->isChecked()) options += "-v ";
    if(ui->cubes->isChecked()) options += "-8 ";

    if(ui->rt->text() != "") options += "-x " + ui->rt->text();
    if(ui->nmq->text() != "") options += "-X " + ui->nmq->text();

    if(ui->toleranceType->currentIndex() == 0) options += "-a ";
    if(ui->toleranceType->currentIndex() == 1) options += "-n ";
    if(ui->toleranceType->currentIndex() == 2) options += "-r ";
    if(ui->toleranceType->currentIndex() == 3) options += "-D ";

    options += QString::number(ui->tolerance->value()) + " ";

    emit optionsSet(options);
    this->close();
}

void DialogExportSTL::on_buttonBox_rejected()
{
    this->close();
}
