#ifndef BRLCAD_EDITOR_H
#define BRLCAD_EDITOR_H

#include "highlightercpp.h"
#include "highlighterascii.h"
#include "dialogexportstl.h"

#include <QMainWindow>
#include <QtWidgets>
#include <iostream>
#include <stdio.h>

//class QTextEdit;

//Has to be edited for other systems or just place wit other bin files then replace with "." <--- that id not emoji
#define BRLCAD_PATH string("/usr/brlcad/bin/")

namespace Ui {
class Editor;
}

class Editor : public QMainWindow
{
    Q_OBJECT

public:
    Editor(QWidget *parent = 0);

public slots:
    void about() { QMessageBox::about(this, tr("About BRL-CAD editor"), tr("<p>The <b>BRL-CAD editr</b> is OpenSCAD like alfa version of C++ script editor</p>")); }
    void newFile();
    void saveFile();
    void saveFileAs();
    void raterace();
    void openFile(const QString &path = QString());
    void openFileAscOrG();
    void refreshRtImage();
    void newExportImportOptions(QString newOptions) { exportImportOptions = newOptions; }

protected:
    bool eventFilter(QObject *watched, QEvent *event);

private slots:
    void exportAs(QString fileName = "");
    void importAs(QString fileName = "");

private:
    Ui::Editor * ui;
    void setupEditor();
    void setupMenu();
    //void setupOptionsMenu();
    //void setupWindowMenu();
    //void setupRaytraceMenu();
    //void setupImportMenu();
    //void setupExportMenu();
    //void setupHelpMenu();
    void setupRtImage();
    void setupErrorLog();

    //QTextEdit *editor;

    bool CppAvailable;

    HighlighterCpp *highlightercpp;
    HighlighterAscii *highlighterascii; //not working linking

    QSignalMapper importMapper;
    QSignalMapper exportMapper;

    QPixmap * rtImage;
    QPixmap * rtImageScaled;
    QAction *fullScreenImage;
    int i;
    QString currentPath;
    QString currentPathPixmap;
    QString currentFileName; // name without extend
    QString currentFileNameExportedAsc; // name without extend

    QString compiler;
    QString additionalFiles;
    QString BRLCADbinPath;

    QString exportImportOptions;
};

#endif // EDITOR_H
